SystemOrganization addCategory: #ExtentionsForKendrick!

Object subclass: #KendrickEquations
	instanceVariableNames: 'eqAsSymExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 13:05'!
convertToCompatibleBackendRepresentation

	^ ((eqAsSymExpr asString
			copyReplaceAll: '#' with: '' asTokens: false)
			trimBoth: [ :c | (c = $() | (c = $)) ]) 
			findTokens: '''.'''! !

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:57'!
with: symExpression

	eqAsSymExpr := symExpression ! !

Object subclass: #KendrickInternalDSLEntities
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

KendrickInternalDSLEntities class
	instanceVariableNames: 'storedInstances'!

KendrickInternalDSLEntities class
	instanceVariableNames: 'storedInstances'!

KendrickInternalDSLEntities subclass: #Kendrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Kendrick class methodsFor: 'public-api' stamp: 'NickPapoulias 4/4/2016 17:44'!
model

	^ KendrickModel new! !

Kendrick subclass: #KendrickModel
	instanceVariableNames: 'population attributes parameters equations keModel explicitelySetCompartments otherCompartmentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 15:59'!
atCompartment: variable value: value

	|assoc|

	assoc := (attributes associations select: [ :as | as value includes: variable ]) first.
	keModel atCompartment: { assoc key -> variable } put: value.! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/4/2016 17:28'!
attributeValuesIncludes: variable

	^ (attributes values select: [ :values | values includes: variable ]) isEmpty not! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:57'!
doesNotUnderstand: aMessage

	|variable value|
	
	variable := aMessage selector.
	variable := (variable asString trimRight: [: c | c =  $:]) asSymbol.
	value := aMessage arguments first.

	value isNumber 
		ifTrue: [   
			(self attributeValuesIncludes: variable)
				ifTrue: [ 
					explicitelySetCompartments add: variable.
					self atCompartment: variable value: value. 
				]
				ifFalse: [ 
					parameters at: variable put: value.
					keModel addParameter: variable value: value 
				]
		] ifFalse: [  
			value isArray
				ifTrue: [ 
					attributes at: variable put: value.
					keModel addAttribute: variable value: value  
				]
				ifFalse: [ KendrickDSLSyntaxError signal: 'Expected a Number or Array got: ' , value asString , ' instead'. ]	
		]
	
	! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 13:06'!
equations: anArrayOfSymExpressions

	equations :=
		KendrickEquations new with: anArrayOfSymExpressions.
	keModel addEquations: equations convertToCompatibleBackendRepresentation.
	! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/4/2016 17:41'!
initialize

	keModel := KEModel new.
	attributes := Dictionary new.
	parameters := Dictionary new.
	explicitelySetCompartments := OrderedCollection new.! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:27'!
keModel

	^ keModel! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 16:05'!
others: anInteger

	otherCompartmentValue := anInteger.

	keModel attributes
		associationsDo: [ :assoc | 
			assoc value do: [:var |
				(explicitelySetCompartments includes: var)
					ifFalse: [ self atCompartment: var value: anInteger ]
			] 
		]! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:51'!
population: anInteger

	population := anInteger.
	keModel population: (KEPopulation size: anInteger).! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:23'!
clearAll

	self allSubclassesDo: [ :subclass | subclass clearAllInstances ]! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:20'!
clearAllInstances

	storedInstances := nil! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:22'!
new

	^ self storedInstances addFirst: self basicNew initialize! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:20'!
storedInstances

	^ storedInstances ifNil: [ storedInstances := OrderedCollection new ]! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:19'!
withId: anId

	^ (self storedInstances select: [ :instance | instance id = anId ]) first.! !

!KendrickInternalDSLEntities methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:51'!
id

	^ id! !

!KendrickInternalDSLEntities methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:52'!
id: aString

	id := aString! !

KendrickInternalDSLEntities subclass: #Simulation
	instanceVariableNames: 'algo model from to step simulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Simulation class methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:24'!
rungeKutta

	^ self new 
		with: #RungeKutta! !

!Simulation methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 15:38'!
allTimeSeries

	^ simulator allTimeSeries ! !

!Simulation methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:27'!
execute

	simulator := KESimulator new: algo from: from to: to step: step.
	simulator executeOn: model keModel.! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:26'!
for: aModelID

	model := KendrickModel withId: aModelID.! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:27'!
from: aNumber

	from := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:29'!
step: aNumber

	step := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:27'!
to: aNumber

	to := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:24'!
with: anAlgorithm

	algo := anAlgorithm ! !

KendrickInternalDSLEntities subclass: #Visualization
	instanceVariableNames: 'simulation xLabel diag builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Visualization class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 15:43'!
diagram

	^ Visualization new 
		with: KEDiagramBuilder! !

!Visualization methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 16:06'!
for: simulationID

	simulation := Simulation withId: simulationID.! !

!Visualization methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:21'!
open

	simulation execute.
	diag := builder new data: simulation allTimeSeries.
	diag xLabel: xLabel.
	diag open! !

!Visualization methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 15:44'!
with: aBuilder

	builder := aBuilder! !

!Visualization methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:36'!
xLabel: aString

	xLabel := aString! !

Error subclass: #KendrickDSLSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

TestCase subclass: #TestMeaslesScripts
	instanceVariableNames: 'beforeSimulator afterSimulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:32'!
after

Kendrick model
	id: 'Measles';
	population: 100000;
	status: #(S E I R); 
	S: 99999;
	I: 1;
	others: 0;
	beta: 0.0000214;
	gamma: 0.143;
	mu: 0.000351;
	sigma: 0.125;
	equations: #(
	   S:t=mu*N - beta*S*I - mu*S.
      E:t=beta*S*I - sigma*E - mu*E.
      I:t=sigma*E - gamma*I - mu*I.
      R:t=gamma*I - mu*R.
	).
	
Simulation rungeKutta
	id: 'MeaslesRKSim';
	for: 'Measles';
	from: 0.0; 
	to: 150; 
	step: 1.
	
Visualization diagram 
	id: 'MeaslesDiagramViz';
	for: 'RKSim';
	xLabel: 'Time (days)'.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:32'!
before

| model simulator diag |
model := KEModel new population: (KEPopulation size: 100000).
model addAttribute: #status value: #(S E I R).
model atCompartment: { #status->#S } put: 99999 atOthersPut: 0.
model atCompartment: { #status->#I } put: 1.
model addEquations: { 
            'S:t=mu*N - beta*S*I - mu*S'.
            'E:t=beta*S*I - sigma*E - mu*E'.
            'I:t=sigma*E - gamma*I - mu*I'.
            'R:t=gamma*I - mu*R'
            }.
model addParameters: {
        #beta->0.0000214. 
        #gamma->0.143. 
        #mu->0.0000351. 
        #sigma->0.125 }.
simulator := KESimulator new: #RungeKutta from: 0.0 to: 150 step: 1.
simulator executeOn: model.
diag := (KEDiagramBuilder new) data: simulator allTimeSeries.
diag xLabel: 'Time (days)'.
diag open.

^ simulator! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:34'!
setUp

	beforeSimulator := self before.
	self after. "we grab it by id to show-case how tools should handle the declarative dsl"
	afterSimulator := Simulation withId: 'MeaslesRKSim'.
	(Visualization withId: 'MeaslesViz') open.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:34'!
tearDown

	KendrickInternalDSLEntities clearAll.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:36'!
testEquivalence

	self assert: 
		beforeSimulator allTimeSeries = afterSimulator allTimeSeries! !
